% Lab 2
% Lists in Prolog
% ===========================

% DATABASE
% ===========================
female(elizabeth).
female(margaret).
female(diana).
female(camilla).
female(sophie).
female(kate).
female(meghan).
female(louise).

male(george).
male(philip).
male(charles).
male(edward).
male(william).
male(harry).
male(james).

parent(george,elizabeth).
parent(george, margaret).
parent(elizabeth,charles).
parent(philip,charles).
parent(elizabeth,edward).
parent(philip,edward).
parent(charles,william).
parent(diana,william).
parent(charles,harry).
parent(diana,harry).
parent(edward,louise).
parent(sophie,louise).
parent(edward,james).
parent(sophie,james).

wife(elizabeth,philip).
wife(diana,charles).
wife(camilla,charles).
wife(sophie,edward).
wife(kate, william).
wife(meghan, harry).
% ===========================


% Task 2
ancestor1(A,D) :- parent(A,D).
ancestor1(A,D) :- parent(A,B), ancestor1(B,D).

ancestor2(A,D) :- parent(A,D).
ancestor2(A,D) :- ancestor2(B,D), parent(A,B).

ancestor3(A,D) :- parent(A,B), ancestor3(B,D).
ancestor3(A,D) :- parent(A,D).

ancestor4(A,D) :- ancestor4(B,D), parent(A,B).
ancestor4(A,D) :- parent(A,D).



% Task 4
list_of_size_one(X) :- [X].

any_list([]).
any_list([_|T]) :- any_list(T).

my_member(X, [X|_]).
my_member(X, [_|T]) :- my_member(X, T).



% Task 5
ancestor(A, D, []) :- parent(A, D).
ancestor(A, D, [X|Others]) :- parent(A, X), ancestor(X, D, Others).



% Task 6
my_append([], L, L).
my_append([H|T], L2, [H|L]) :- my_append(T, L2, L).


% Task 8
my_reverse_naive([], []).
my_reverse_naive([H|T], Rev) :- my_reverse_naive(T, Rev2), my_append(Rev2, [H], Rev).



% Task 9
minimum([H|List], Min) :- min_acc(List, Min, H).
min_acc([], Min, Min).
min_acc([H|List], Min, Acc) :- H < Acc, min_acc(List, Min, H).
min_acc([H|List], Min, Acc) :- H >= Acc, min_acc(List, Min, Acc).



% Task 10
my_reverse(List, Reversed) :- my_reverse_acc(List, Reversed, []).
my_reverse_acc([], Reversed, Reversed).
my_reverse_acc([H|T], Reversed, Acc) :- my_reverse_acc(T, Reversed, [H|Acc]).



% Task 11
my_select(Elem, [Elem|Rest], Rest).
my_select(Elem, [H|List], [H|Rest]) :- my_select(Elem, List, Rest).



% Task 12
ancestor_all(A, D, [A|List]) :- anc_acc(A, D, List, [D]).
anc_acc(A, D, List, List) :- parent(A, D).
anc_acc(A, D, List, Acc) :- parent(X, D), anc_acc(A, X, List, [X|Acc]).



% Task 13
my_flatten([], []).
my_flatten([H|T], Flat) :- 
    any_list(H),
    my_flatten(H, FlatHead),
    my_flatten(T, FlatTail),
    my_append(FlatHead, FlatTail, Flat).
my_flatten([H|T], [H|Flat]) :- my_flatten(T, Flat).
